﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Classy_1;
using Clio.Utilities;
using Clio.XmlEngine;
using ff14bot.Behavior;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.NeoProfiles;
using ff14bot.RemoteWindows;
using TreeSharp;
using System.Threading;
using Action = TreeSharp.Action;

namespace ff14bot.NeoProfile
{

    [XmlElement("ChangeJob")]
    class ChangeJobTag : ProfileBehavior
    {
        private bool _done;
        Vector3 location = Poi.Current.Location;
        private Form1 _form;
        [XmlAttribute("Type")]
        public string Type { get; set; }

        public override bool IsDone { get { return _done; } }

        //this is the only part I am curious about in this class - is this the correct way to do this?
        //this sends Type(Job reference in profile) to the sendkey class, where it is compaired to the dictionary and
        //pulls the value for the keybind to send to the client.
        protected new Composite Behavior()
        {

            var binding = Form1.bindings;
            string currentJob = Core.Me.CurrentJob.ToString();
            string selectedJob = Enum.Parse(typeof(Enums.ClassJobType), Type, true).ToString();
            
            string selecting;
            return new PrioritySelector(
                new Decorator(ret => !Core.Me.InCombat && !IsDone && !IsSameJob(currentJob, selectedJob),
                    new Action(r =>
                    {
                        Logging.Write("[Classy] - Changing gearset");
                        binding.TryGetValue(Type, out selecting);
                        Logging.Write("[Classy] - Found - sending message");
                        string message = "/gs change " + selecting;
                      
                        ChatManager.SendChat(message);
                        Logging.Write("[Classy] - message set - should be changed.");
                        _done = true;
                     


                    }


                    )));

        }

        public bool IsSameJob(string type1, string type2)
        {
            return (string.Compare(type1, type2, true) == 0);
        }


        public void ResetCachedDone()
        {
            _done = false;
        }


        private Composite _cache;

        protected override void OnStart()
        {
            _cache = Behavior();
            TreeHooks.Instance.InsertHook("TreeStart", 0, _cache);
        }

        protected override void OnDone()
        {
            Logging.Write("[Classy] - OnDone() Called");
            Poi.Current = new Poi(location, PoiType.Gather);
            Logging.Write("[Classy] - Current POI should be set");
        }

    }



}
